## ros-melodic-qpmad 1.0.2

=== CMakeLists.txt ===
# General parameters
cmake_minimum_required(VERSION 3.0)
project(qpmad VERSION 1.0.2)


# --------------
# Options
# --------------
set(CMAKE_VERBOSE_MAKEFILE          ON)
option(QPMAD_BUILD_TESTS        "Build tests"                                           OFF)
option(QPMAD_ENABLE_TRACING     "Enable tracing"                                        OFF)
option(QPMAD_USE_HOUSEHOLDER    "Use Housholder matrices for updating factorizations"   OFF)
# --------------


# --------------
# Process options
# --------------
if(NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Debug)
endif (NOT CMAKE_BUILD_TYPE)

set(QPMAD_SOURCE_DIR   "${PROJECT_SOURCE_DIR}/include/")
# --------------


# --------------
# Load cmake modules
# --------------
include(CMakeParseArguments)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
# --------------


# --------------
# Dependencies
# --------------
# Eigen
find_package(Eigen3 REQUIRED)
include_directories (SYSTEM "${EIGEN3_INCLUDE_DIR}")
set(Eigen_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
# --------------


# --------------
# Packaging
# --------------
set(QPMAD_INCLUDE_INSTALL_DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME})
set(QPMAD_CMAKE_INSTALL_DESTINATION "${CMAKE_INSTALL_PREFIX}/share/${CMAKE_PROJECT_NAME}/cmake/")

include(CMakePackageConfigHelpers)
configure_package_config_file(  "cmake/${CMAKE_PROJECT_NAME}Config.cmake.in"
                                "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
                                INSTALL_DESTINATION "${QPMAD_CMAKE_INSTALL_DESTINATION}"
                                NO_SET_AND_CHECK_MACRO
                                NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(
    ${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
    COMPATIBILITY SameMajorVersion)
# --------------


# --------------
# Dependencies
# --------------
# eigenut
option(EIGENUT_EMBEDDED "" ON)
set(EIGENUT_EMBEDDED_ID "QPMAD_UTILS"  CACHE STRING "")
set(EIGENUT_EMBEDDED_COPY_TO_DIR "${QPMAD_SOURCE_DIR}/${CMAKE_PROJECT_NAME}"  CACHE STRING "")
set(EIGENUT_SELECT_HEADERS "config.h;types.h;misc.h"  CACHE STRING "")
add_subdirectory(eigenut)
# --------------


# --------------
# Configure headers
# --------------
include_directories("${QPMAD_SOURCE_DIR}")

configure_file( "${QPMAD_SOURCE_DIR}/${CMAKE_PROJECT_NAME}/config.h.in"
                "${QPMAD_SOURCE_DIR}/${CMAKE_PROJECT_NAME}/config.h")


get_property(QPMAD_OCTAVE_INCLUDES DIRECTORY "${PROJECT_SOURCE_DIR}" PROPERTY INCLUDE_DIRECTORIES)
list(REMOVE_DUPLICATES QPMAD_OCTAVE_INCLUDES)
string(REPLACE ";" " -I" QPMAD_OCTAVE_INCLUDES "${QPMAD_OCTAVE_INCLUDES}")
set(QPMAD_OCTAVE_INCLUDES "-I${QPMAD_OCTAVE_INCLUDES}")

configure_file( "${PROJECT_SOURCE_DIR}/matlab_octave/make.m.in"
                "${PROJECT_SOURCE_DIR}/matlab_octave/make.m")
# --------------


# --------------
# tests
# --------------
if (QPMAD_BUILD_TESTS)
    enable_testing()
    add_subdirectory("${PROJECT_SOURCE_DIR}/test")
endif(QPMAD_BUILD_TESTS)
# --------------


# --------------
# Install
# --------------
install (FILES "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
         DESTINATION "${QPMAD_CMAKE_INSTALL_DESTINATION}/")

install (FILES "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake"
         DESTINATION "${QPMAD_CMAKE_INSTALL_DESTINATION}/")

install (DIRECTORY "${QPMAD_SOURCE_DIR}/${CMAKE_PROJECT_NAME}/"
         DESTINATION "${QPMAD_INCLUDE_INSTALL_DESTINATION}"
         FILES_MATCHING PATTERN "*.h")
# --------------

=== Makefile ===
REPO=https://github.com/asherikov/qpmad.git
BUILD_DIR?=build
MAKE_FLAGS?=-j5
VERSION?="XXX__version_not_set__XXX"

TYPE?=Debug
TRACING?=OFF
EXTRA_CMAKE_PARAM?=
#EXTRA_CMAKE_PARAM?="-DCMAKE_CXX_COMPILER=g++"


default:
	@grep -v "^	" Makefile | grep -v "^$$"


build:
	${MAKE}	cmake TYPE=Release TRACING=OFF TESTS=OFF

install:
	cd ${BUILD_DIR}; ${MAKE} install


test: clean unit_tests_without_tracing unit_tests_with_tracing unit_tests_with_householder test_octave

test_octave:
	cd matlab_octave; ${MAKE} octave octave_test

test_dependency: clean
	mkdir -p build/dependency_test
	cd build/dependency_test; cmake ../../test/dependency/
	cd build/dependency_test; ${MAKE} ${MAKE_FLAGS}


# build targets
#----------------------------------------------

build_with_householder:
	${MAKE} cmake TYPE=Debug TRACING=OFF EXTRA_CMAKE_PARAM="-DQPMAD_USE_HOUSEHOLDER=ON"

unit_tests_with_householder: build_with_householder
	cd ${BUILD_DIR}; ${MAKE} test


build_without_tracing:
	${MAKE}	cmake TYPE=Debug TRACING=OFF TESTS=ON

unit_tests_without_tracing: build_without_tracing
	cd ${BUILD_DIR}; ${MAKE} test


build_with_tracing:
	${MAKE}	cmake TYPE=Debug TRACING=ON TESTS=ON

unit_tests_with_tracing: build_with_tracing
	cd ${BUILD_DIR}; ${MAKE} test


cmake:
	mkdir -p ${BUILD_DIR};
	cd ${BUILD_DIR}; cmake .. \
						-DQPMAD_BUILD_TESTS=${TESTS} \
						-DCMAKE_BUILD_TYPE=${TYPE} \
						-DQPMAD_ENABLE_TRACING=${TRACING} \
						${EXTRA_CMAKE_PARAM}
	cd ${BUILD_DIR}; ${MAKE} ${MAKE_FLAGS}


# utils
#----------------------------------------------

addutils:
	git remote add cmakeut https://github.com/asherikov/cmakeut --no-tags
	git remote add eigenut https://github.com/asherikov/eigenut --no-tags

updateutils:
	git fetch --all
	git rm --ignore-unmatch -rf eigenut
	git read-tree --prefix=eigenut -u eigenut/master
	git show remotes/cmakeut/master:cmake/FindEigen3.cmake                  > cmake/FindEigen3.cmake
	#git show remotes/cmakeut/master:cmake/cmakeut_add_cpp_test.cmake        > cmake/cmakeut_add_cpp_test.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_compiler_flags.cmake      > cmake/cmakeut_compiler_flags.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_detect_func_macro.cmake   > cmake/cmakeut_detect_func_macro.cmake


# release
#----------------------------------------------

update_version:
	sed -i -e "s=<version>[0-9]*\.[0-9]*\.[0-9]*</version>=<version>${VERSION}</version>=" package.xml
	sed -i -e "s=\(project([ a-zA-Z0-9_-]* VERSION\) [0-9]*\.[0-9]*\.[0-9]*)=\1 ${VERSION})=" CMakeLists.txt

ros_release:
	# 0. Add Forthcoming section to the changelog
	${MAKE} update_version VERSION=${VERSION}
	git commit -a
	catkin_prepare_release -t 'ros-' --version "${VERSION}" -y
	# initial release -> https://wiki.ros.org/bloom/Tutorials/FirstTimeRelease
	# subsequent releases -> bloom-release --rosdistro melodic --track melodic qpmad


# catkin
#----------------------------------------------

CATKIN_WORKING_DIR?=./build/catkin_workspace
PKG_PATH?=${CATKIN_WORKING_DIR}/src/qpmad
DEPENDENT_PKG_PATH?=${CATKIN_WORKING_DIR}/src/qpmad_catkin_dependency_test

add-ros-repos:
	sh -c "echo \"deb http://packages.ros.org/ros/ubuntu ${UBUNTU_DISTRO} main\" > /etc/apt/sources.list.d/ros-latest.list"
	sh -c "apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654 \
        || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654 \
        || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654"
	sh -c "apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157 \
        || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157 \
        || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157"
	apt-get update -qq
	apt-get install dpkg



install-deps:
	apt update
#	apt upgrade -y
	apt install -y \
        libeigen3-dev
	apt install -y \
		python-bloom \
		devscripts \
		debhelper
	apt install -y python-catkin-tools


catkin-build-deb: clean
	cd ${PKG_PATH}; bloom-generate rosdebian --os-name ubuntu --ros-distro ${ROS_DISTRO} ./
	# disable installation of catkin stuff: setup scripts, etc.
	#cd ${PKG_PATH}; sed "s/dh_auto_configure --/dh_auto_configure -- -DCATKIN_BUILD_BINARY_PACKAGE=ON/" -i debian/rules
	cd ${PKG_PATH}; fakeroot debian/rules binary


catkin-test-deb: catkin-build-deb
	sudo dpkg -i ../ros*qpmad*.deb
	mkdir -p build/dependency_test
	bash -c 'source /opt/ros/${ROS_DISTRO}/setup.bash; \
             cd build/dependency_test; \
             cmake ../../test/dependency/; \
             ${MAKE} ${MAKE_FLAGS}'


catkin-prepare-workspace: clean
	mkdir -p ${PKG_PATH}
	mkdir -p ${DEPENDENT_PKG_PATH}
	ls -1 | grep -v build | xargs cp -R -t ${PKG_PATH}
	cp -R test/dependency/* ${DEPENDENT_PKG_PATH}/


catkin-old-build: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated --pkg qpmad --make-args all # old

catkin-old-build-with-dependent: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated

catkin-old-deb: catkin-prepare-workspace
	${MAKE} catkin-test-deb
	${MAKE} catkin-prepare-workspace
	rm -Rf ${PKG_PATH}
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated --pkg qpmad_catkin_dependency_test


catkin-new-build: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary qpmad --make-args all

catkin-new-build-with-dependent: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary qpmad_catkin_dependency_test

catkin-new-deb:
	${MAKE} catkin-test-deb
	${MAKE} catkin-prepare-workspace
	rm -Rf ${PKG_PATH}
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary qpmad_catkin_dependency_test


catkin-test-old: install-deps
	${MAKE} catkin-old-build
	${MAKE} catkin-old-build-with-dependent
	${MAKE} catkin-old-deb

catkin-test-new: install-deps
	${MAKE} catkin-new-build
	${MAKE} catkin-new-build-with-dependent
	${MAKE} catkin-new-deb


ros-prerelease-deps:
	sudo ${MAKE} add-ros-repos UBUNTU_DISTRO=${UBUNTU_DISTRO}
	sudo apt-get install python3-ros-buildfarm

ros-prerelease: ros-prerelease-deps
	# sudo apt install docker.io
	# sudo adduser username docker
	generate_prerelease_script.py \
		https://raw.githubusercontent.com/ros-infrastructure/ros_buildfarm_config/production/index.yaml \
		${ROS_DISTRO} default ubuntu ${UBUNTU_DISTRO} amd64 qpmad \
		--level 0 --custom-repo qpmad:git:${REPO}:${BRANCH} \
		--output-dir ./build/ros-prerelease
	cd ./build/ros-prerelease; sed -i -e "/_ls_prerelease_scripts=/d" prerelease.sh
	cd ./build/ros-prerelease; env ABORT_ON_TEST_FAILURE=1 ./prerelease.sh


# docker
#----------------------------------------------
make-docker:
	docker pull ros:${ROS_DISTRO}-ros-base-${UBUNTU_DISTRO}
	docker run -ti ros:${ROS_DISTRO}-ros-base-${UBUNTU_DISTRO} \
		/bin/bash -c "source /opt/ros/${ROS_DISTRO}/setup.bash \
		&& git clone -b ${BRANCH} ${REPO} \
		&& cd qpmad \
		&& make ${TARGET} ROS_DISTRO=${ROS_DISTRO} UBUNTU_DISTRO=${UBUNTU_DISTRO}"

# clean
#----------------------------------------------

doxclean:
	cd doc/dox; git fetch --all; git checkout gh-pages; git pull
	find ./doc/dox/ -mindepth 1 -not -name "\.git" | xargs rm -Rf

dox: doxclean clean
	${MAKE} build
	cd doc; doxygen


# clean
#----------------------------------------------

clean:
	rm -Rf ${BUILD_DIR}
	rm -Rf include/qpmad/config.h
	rm -Rf include/qpmad/eigenut*.h
	rm -Rf debian/ obj-*/
	cd matlab_octave; ${MAKE} clean
	cd eigenut; ${MAKE} clean

forceclean: clean
	cd matlab_octave; ${MAKE} forceclean

.PHONY: build cmake test

=== eigenut/CMakeLists.txt ===
# General parameters
cmake_minimum_required (VERSION 3.0.0)
project (eigenut CXX)


# --------------
# Options
# --------------
set(CMAKE_VERBOSE_MAKEFILE          ON)
option(EIGENUT_EMBEDDED             "Embedded in another project" OFF)
option(EIGENUT_BUILD_TESTS          "Build tests" ON)
set(EIGENUT_EMBEDDED_ID             "" CACHE STRING "Overrides header guards, namespace.")
set(EIGENUT_EMBEDDED_COPY_TO_DIR    "" CACHE STRING "Installation destination.")
set(EIGENUT_SELECT_HEADERS          "" CACHE STRING "Selection a subset of headers for installation.")
# --------------


# --------------
# Process options
# --------------
set(EIGENUT_ID "EIGENUT")
if (EIGENUT_EMBEDDED)
    set(EIGENUT_BUILD_TESTS          OFF)
    if(EIGENUT_EMBEDDED_ID)
        set(EIGENUT_ID "${EIGENUT_EMBEDDED_ID}")
    endif()
    if(NOT EIGENUT_EMBEDDED_COPY_TO_DIR)
        message(FATAL_ERROR "EIGENUT_EMBEDDED_COPY_TO_DIR must be set with EIGENUT_EMBEDDED=ON")
    endif()
else()
    if (EIGENUT_EMBEDDED_ID OR EIGENUT_EMBEDDED_COPY_TO_DIR)
        message(WARNING "EIGENUT_EMBEDDED_ID and EIGENUT_EMBEDDED_COPY_TO_DIR ignored since EIGENUT_EMBEDDED=OFF")
    endif()

    # Detect catkin
    if(CATKIN_DEVEL_PREFIX)
        message(STATUS "Building with catkin.")
        set(EIGENUT_CATKIN_BUILD ON)

        if(CATKIN_ENABLE_TESTING)
            set(EIGENUT_BUILD_TESTS ON)
        else()
            set(EIGENUT_BUILD_TESTS OFF)
        endif()
    endif()
endif()

string(TOLOWER "${EIGENUT_ID}" EIGENUT_ID_LOWER_CASE)

set(EIGENUT_HEADER_DIR "${PROJECT_SOURCE_DIR}/include/eigenut")
# --------------


# --------------
# Load cmake modules
# --------------
include(CMakeParseArguments)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
# --------------


# --------------
# Dependencies
# --------------
# Eigen
find_package(Eigen3 REQUIRED)
include_directories (SYSTEM "${EIGEN3_INCLUDE_DIR}")
set(Eigen_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
# --------------


# --------------
# Packaging
# --------------
if (EIGENUT_CATKIN_BUILD)
    find_package(catkin REQUIRED)
    catkin_package(
        INCLUDE_DIRS include
        DEPENDS Eigen
    )
else()
    set(PROJECT_VERSION_MAJOR 1)
    set(PROJECT_VERSION_MINOR 0)
    set(PROJECT_VERSION_PATCH 1)

    if (NOT EIGENUT_EMBEDDED)
        include(CMakePackageConfigHelpers)
        set(EIGENUT_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/share/eigenut/")
        set(EIGENUT_INCLUDES "${CMAKE_INSTALL_PREFIX}/include")

        configure_package_config_file(  "cmake/eigenutConfig.cmake.in"
                                        "${PROJECT_BINARY_DIR}/eigenutConfig.cmake"
                                        INSTALL_DESTINATION "${CMAKE_INSTALL_PREFIX}/share/eigenut/"
                                        NO_SET_AND_CHECK_MACRO
                                        NO_CHECK_REQUIRED_COMPONENTS_MACRO)

        write_basic_package_version_file(
            ${PROJECT_BINARY_DIR}/eigenutConfigVersion.cmake
            VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            COMPATIBILITY SameMajorVersion)
    endif()
endif()

if (EIGENUT_CATKIN_BUILD)
    set(EIGENUT_INCLUDE_INSTALL_DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
else()
    if (NOT EIGENUT_EMBEDDED)
        set(EIGENUT_INCLUDE_INSTALL_DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${EIGENUT_ID_LOWER_CASE})
    endif()
endif()
# --------------


# --------------
# Dependencies
# --------------
# cpput
option(CPPUT_EMBEDDED "" ON)
set(CPPUT_EMBEDDED_ID "${EIGENUT_ID}"  CACHE STRING "")
if (EIGENUT_EMBEDDED_COPY_TO_DIR)
    set(CPPUT_EMBEDDED_COPY_TO_DIR "${EIGENUT_EMBEDDED_COPY_TO_DIR}"  CACHE STRING "")
else()
    set(CPPUT_EMBEDDED_COPY_TO_DIR "${EIGENUT_HEADER_DIR}"  CACHE STRING "")
endif()
set(CPPUT_SELECT_HEADERS "config.h;exception.h;visibility.h"  CACHE STRING "")
add_subdirectory(cpput)
# --------------


# --------------
# Configure headers
# --------------
include(cmakeut_list_filenames)

cmakeut_list_filenames("${EIGENUT_HEADER_DIR}/" "EIGENUT_HEADERS")
foreach (EIGENUT_HEADER ${EIGENUT_HEADERS})
    if (${EIGENUT_HEADER} MATCHES ".h.in\$")
        string(REPLACE ".h.in" ".h" EIGENUT_HEADER_NO_SUFFIX "${EIGENUT_HEADER}")
        message("Configuring header ${EIGENUT_HEADER} -> ${EIGENUT_HEADER_NO_SUFFIX}")
        configure_file( "${EIGENUT_HEADER_DIR}/${EIGENUT_HEADER}"
                        "${EIGENUT_HEADER_DIR}/${EIGENUT_HEADER_NO_SUFFIX}")
    endif()
endforeach()

include_directories ("${PROJECT_SOURCE_DIR}/include")
# --------------


# --------------
# Tests
# --------------
if(EIGENUT_BUILD_TESTS)
    enable_testing()
    add_subdirectory("${PROJECT_SOURCE_DIR}/test")
endif()
# --------------


# --------------
# Install
# --------------
if (EIGENUT_EMBEDDED)
    if (NOT EIGENUT_SELECT_HEADERS)
        cmakeut_list_filenames("${EIGENUT_HEADER_DIR}/" "EIGENUT_HEADERS")
        foreach (EIGENUT_HEADER ${EIGENUT_HEADERS})
            if (NOT ${EIGENUT_HEADER} MATCHES ".h.in\$" AND NOT ${EIGENUT_HEADER} MATCHES "all.h")
                list(APPEND EIGENUT_SELECT_HEADERS "${EIGENUT_HEADER}")
            endif()
        endforeach()
    endif()

    if (EIGENUT_SELECT_HEADERS)
        foreach (EIGENUT_HEADER ${EIGENUT_SELECT_HEADERS})
            if (EIGENUT_HEADER)
                file(   COPY        "${EIGENUT_HEADER_DIR}/${EIGENUT_HEADER}"
                        DESTINATION "${PROJECT_BINARY_DIR}/")
                file(   RENAME      "${PROJECT_BINARY_DIR}/${EIGENUT_HEADER}"
                                    "${EIGENUT_EMBEDDED_COPY_TO_DIR}/eigenut_${EIGENUT_HEADER}")
            endif()
        endforeach()
    endif()
else()
    if (NOT EIGENUT_CATKIN_BUILD)
        install (FILES "${PROJECT_BINARY_DIR}/eigenutConfig.cmake"
                 DESTINATION "${EIGENUT_INSTALL_PATH}/")

        install (FILES "${PROJECT_BINARY_DIR}/eigenutConfigVersion.cmake"
                 DESTINATION "${EIGENUT_INSTALL_PATH}/")
    endif()

    if (EIGENUT_SELECT_HEADERS)
        foreach (EIGENUT_HEADER ${EIGENUT_SELECT_HEADERS})
            if (EIGENUT_HEADER)
                install (FILES "${EIGENUT_HEADER_DIR}/${EIGENUT_HEADER}"
                         DESTINATION "${EIGENUT_INCLUDE_INSTALL_DESTINATION}/")
            endif()
        endforeach()
    else()
        install (DIRECTORY "${EIGENUT_HEADER_DIR}/"
                 DESTINATION "${EIGENUT_INCLUDE_INSTALL_DESTINATION}"
                 FILES_MATCHING PATTERN "*.h")
    endif()
endif()
# --------------

=== eigenut/Makefile ===
BUILD_DIR?=build
MAKE_FLAGS?=-j1

INCLUDE_DIR=include/eigenut/

default:
	@grep -v "^	" Makefile | grep -v "^$$"

clean:
	rm -Rf ${BUILD_DIR}
	ls ${INCLUDE_DIR}/*.in | sed 's/\.in$$//g' | xargs rm -f
	ls ${INCLUDE_DIR}/*.in | sed 's/\.in$$//g' | sed 's=${INCLUDE_DIR}/=${INCLUDE_DIR}/eigenut_=' | xargs rm -f
	rm -Rf ${INCLUDE_DIR}/cpput*.h
	cd cpput; ${MAKE} clean

build:
	git submodule update --init
	mkdir -p ${BUILD_DIR}
	cd ${BUILD_DIR}; cmake ..
	cd ${BUILD_DIR}; make ${MAKE_FLAGS}

test: build
	cd build; ${MAKE} ${MAKE_FLAGS} test

gitignore:
	echo "build" > .gitignore
	ls ${INCLUDE_DIR}*.in | sed 's/\.in$$//g' >> .gitignore
	ls ${INCLUDE_DIR}*.in | sed 's/\.in$$//g' | sed 's=${INCLUDE_DIR}=${INCLUDE_DIR}eigenut_=' >> .gitignore

#----------------------------------------------
# utils
#----------------------------------------------

addutils:
	git remote remove cpput
	git remote remove cmakeut
	git remote add cmakeut https://github.com/asherikov/cmakeut
	git remote add cpput https://github.com/asherikov/cpput

updateutils:
	git fetch --all
	git rm --ignore-unmatch -rf cpput
	git read-tree --prefix=cpput -u cpput/master
	rm -Rf cpput/3rdparty/
	git show remotes/cmakeut/master:cmake/FindEigen3.cmake                  > cmake/FindEigen3.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_add_cpp_test.cmake        > cmake/cmakeut_add_cpp_test.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_compiler_flags.cmake      > cmake/cmakeut_compiler_flags.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_detect_func_macro.cmake   > cmake/cmakeut_detect_func_macro.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_list_filenames.cmake      > cmake/cmakeut_list_filenames.cmake

.PHONY: build test

=== matlab_octave/Makefile ===
octave: forceclean configure
	octave --no-history --silent make.m

matlab: forceclean configure
	matlab -nosplash -nodesktop -nojvm -r 'make; quit' | tail +10


octave_test: octave_onlineqp octave_basic

octave_basic:
	octave --no-history --silent test_basic.m

octave_onlineqp:
	git submodule update --init
	cd onlineqp_collection; ${MAKE} fetch
	octave --no-history --silent test_onlineqp.m


configure:
	cp config.h ../include/qpmad/


clean:
	rm -f *.o

forceclean: clean
	rm -f *.mex*

=== test/CMakeLists.txt ===
include(cmakeut_compiler_flags)
cmakeut_compiler_flags("c++98")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKEUT_CXX_FLAGS} -Wno-c99-extensions")

include(qpmad_add_test)

find_package(Boost REQUIRED unit_test_framework timer system)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

get_cmake_property(VARNAMES VARIABLES)

qpmad_add_test("test_givens" "givens.cpp")
qpmad_add_test("test_cholesky" "cholesky.cpp")
qpmad_add_test("test_inverse" "inverse.cpp")
qpmad_add_test("test_solver" "solver.cpp")

=== eigenut/cpput/CMakeLists.txt ===
# General parameters
cmake_minimum_required (VERSION 3.0.0)
project (cpput CXX)


# --------------
# Options
# --------------
set(CMAKE_VERBOSE_MAKEFILE      ON)
option(CPPUT_EMBEDDED           "Embedded in another project" OFF)
option(CPPUT_BUILD_TESTS        "Build tests" ON)
set(CPPUT_EMBEDDED_ID           "" CACHE STRING "Overrides header guards, namespace (does not apply to 3rdparty headers).")
set(CPPUT_EMBEDDED_COPY_TO_DIR  "" CACHE STRING "Installation destination.")
set(CPPUT_SELECT_HEADERS        "" CACHE STRING "Selection a subset of headers for installation.")
# --------------


# --------------
# Process options
# --------------
set(CPPUT_ID "CPPUT")
if (CPPUT_EMBEDDED)
    set(CPPUT_BUILD_TESTS          OFF)
    if(CPPUT_EMBEDDED_ID)
        set(CPPUT_ID "${CPPUT_EMBEDDED_ID}")
    endif()
    if(NOT CPPUT_EMBEDDED_COPY_TO_DIR)
        message(FATAL_ERROR "CPPUT_EMBEDDED_COPY_TO_DIR must be set with CPPUT_EMBEDDED=ON")
    endif()
else()
    if (CPPUT_EMBEDDED_ID OR CPPUT_EMBEDDED_COPY_TO_DIR)
        message(WARNING "CPPUT_EMBEDDED_ID and CPPUT_EMBEDDED_COPY_TO_DIR ignored since CPPUT_EMBEDDED=OFF")
    endif()

    # Detect catkin
    if(CATKIN_DEVEL_PREFIX)
        message(STATUS "Building with catkin.")
        set(CPPUT_CATKIN_BUILD ON)

        if(CATKIN_ENABLE_TESTING)
            set(CPPUT_BUILD_TESTS ON)
        else()
            set(CPPUT_BUILD_TESTS OFF)
        endif()
    endif()
endif()

string(TOLOWER "${CPPUT_ID}" CPPUT_ID_LOWER_CASE)

set(CPPUT_HEADER_DIR "${PROJECT_SOURCE_DIR}/include/cpput")
# --------------


# --------------
# Packaging & installation paths
# --------------
if (CPPUT_CATKIN_BUILD)
    find_package(catkin REQUIRED)
    catkin_package(INCLUDE_DIRS include)
else()
    set(PROJECT_VERSION_MAJOR 1)
    set(PROJECT_VERSION_MINOR 0)
    set(PROJECT_VERSION_PATCH 0)

    if (NOT CPPUT_EMBEDDED)
        include(CMakePackageConfigHelpers)
        set(CPPUT_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/share/cpput/")
        set(CPPUT_INCLUDES "${CMAKE_INSTALL_PREFIX}/include")

        configure_package_config_file(  "cmake/cpputConfig.cmake.in"
                                        "${PROJECT_BINARY_DIR}/cpputConfig.cmake"
                                        INSTALL_DESTINATION "${CMAKE_INSTALL_PREFIX}/share/cpput/"
                                        NO_SET_AND_CHECK_MACRO
                                        NO_CHECK_REQUIRED_COMPONENTS_MACRO)

        write_basic_package_version_file(
            ${PROJECT_BINARY_DIR}/cpputConfigVersion.cmake
            VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            COMPATIBILITY SameMajorVersion)
    endif()
endif()


if (CPPUT_CATKIN_BUILD)
    set(CPPUT_INCLUDE_INSTALL_DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
else()
    if (NOT CPPUT_EMBEDDED)
        set(CPPUT_INCLUDE_INSTALL_DESTINATION ${CMAKE_INSTALL_PREFIX}/include/${CPPUT_ID_LOWER_CASE})
    endif()
endif()
# --------------


# --------------
# Load cmake modules
# --------------
include(CMakeParseArguments)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")
# --------------


# --------------
# Configure headers
# --------------
include(cmakeut_list_filenames)
include(cmakeut_detect_func_macro)
cmakeut_detect_func_macro()

cmakeut_list_filenames("${CPPUT_HEADER_DIR}/" "CPPUT_HEADERS")
foreach (CPPUT_HEADER ${CPPUT_HEADERS})
    if (${CPPUT_HEADER} MATCHES ".h.in\$")
        string(REPLACE ".h.in" ".h" CPPUT_HEADER_NO_SUFFIX "${CPPUT_HEADER}")
        message("Configuring header ${CPPUT_HEADER} -> ${CPPUT_HEADER_NO_SUFFIX}")
        configure_file( "${CPPUT_HEADER_DIR}/${CPPUT_HEADER}"
                        "${CPPUT_HEADER_DIR}/${CPPUT_HEADER_NO_SUFFIX}")
    endif()
endforeach()

include_directories ("${PROJECT_SOURCE_DIR}/include")
# --------------


# --------------
# tests
# --------------
if(CPPUT_BUILD_TESTS)
    enable_testing()
    add_subdirectory("${PROJECT_SOURCE_DIR}/test")
endif()
# --------------


# --------------
# Install
# --------------
if (CPPUT_EMBEDDED)
    if (NOT CPPUT_SELECT_HEADERS)
        cmakeut_list_filenames("${CPPUT_HEADER_DIR}/" "CPPUT_HEADERS")
        foreach (CPPUT_HEADER ${CPPUT_HEADERS})
            if (NOT ${CPPUT_HEADER} MATCHES ".h.in\$" AND NOT ${CPPUT_HEADER} MATCHES "all.h")
                list(APPEND CPPUT_SELECT_HEADERS "${CPPUT_HEADER}")
            endif()
        endforeach()
    endif()

    if (CPPUT_SELECT_HEADERS)
        foreach (CPPUT_HEADER ${CPPUT_SELECT_HEADERS})
            if (CPPUT_HEADER)
                file(   COPY        "${CPPUT_HEADER_DIR}/${CPPUT_HEADER}"
                        DESTINATION "${PROJECT_BINARY_DIR}/")
                file(   RENAME      "${PROJECT_BINARY_DIR}/${CPPUT_HEADER}"
                                    "${CPPUT_EMBEDDED_COPY_TO_DIR}/cpput_${CPPUT_HEADER}")
            endif()
        endforeach()
    endif()
else()
    if (NOT CPPUT_CATKIN_BUILD)
        install (FILES "${PROJECT_BINARY_DIR}/cpputConfig.cmake"
                 DESTINATION "${CPPUT_INSTALL_PATH}/")

        install (FILES "${PROJECT_BINARY_DIR}/cpputConfigVersion.cmake"
                 DESTINATION "${CPPUT_INSTALL_PATH}/")
    endif()

    if (CPPUT_SELECT_HEADERS)
        foreach (CPPUT_HEADER ${CPPUT_SELECT_HEADERS})
            if (CPPUT_HEADER)
                install (FILES "${CPPUT_HEADER_DIR}/${CPPUT_HEADER}"
                         DESTINATION "${CPPUT_INCLUDE_INSTALL_DESTINATION}/")
            endif()
        endforeach()
    else()
        install (DIRECTORY "${CPPUT_HEADER_DIR}/"
                 DESTINATION "${CPPUT_INCLUDE_INSTALL_DESTINATION}"
                 FILES_MATCHING PATTERN "*.h")
    endif()
endif()
# --------------

=== eigenut/test/CMakeLists.txt ===
include(cmakeut_compiler_flags)
cmakeut_compiler_flags("c++03")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKEUT_CXX_FLAGS}")


set(TEST_LIBS "")
set(TEST_TARGETS "")
set(TEST_FLAGS "")
include(cmakeut_add_cpp_test)

# --------------
find_package(Boost REQUIRED unit_test_framework timer system)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
set(TEST_LIBS "${TEST_LIBS};${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES};${Boost_SYSTEM_LIBRARIES};${Boost_TIMER_LIBRARIES}")
set(TEST_FLAGS "${TEST_FLAGS};-Wno-c99-extensions")
# --------------


cmakeut_add_cpp_test(inclusion LIBS "${TEST_LIBS}" FLAGS "${TEST_FLAGS}")
cmakeut_add_cpp_test(blockmatrix LIBS "${TEST_LIBS}" FLAGS "${TEST_FLAGS}")
cmakeut_add_cpp_test(misc LIBS "${TEST_LIBS}" FLAGS "${TEST_FLAGS}")

=== matlab_octave/onlineqp_collection/Makefile ===
DATA_FOLDERS=oqp problems

fetch: ${DATA_FOLDERS}

oqp:
	${MAKE} fetch_qpoases
problems:
	${MAKE} fetch_qpoases

fetch_qpoases:
	svn export https://projects.coin-or.org/svn/qpOASES/misc/testingdata/cpp . --force

clean:

forceclean:
	rm -Rf ${DATA_FOLDERS}

=== test/dependency/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(CMAKE_VERBOSE_MAKEFILE ON)


if (DEFINED CATKIN_DEVEL_PREFIX)
    project(qpmad_catkin_dependency_test)

    find_package(catkin REQUIRED qpmad)

    catkin_package(DEPENDS qpmad)

    include_directories(
        include
        SYSTEM ${catkin_INCLUDE_DIRS}
    )

    add_executable(demo demo.cpp)

    target_link_libraries(demo ${catkin_LIBRARIES})

    install(TARGETS demo
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    )
else()
    project(qpmad_cmake_dependency_test)

    find_package(qpmad REQUIRED)

    include_directories(${qpmad_INCLUDE_DIRS})

    add_executable(demo demo.cpp)
    target_link_libraries(demo ${qpmad_LIBRARIES})
endif()

=== debian/changelog ===
ros-melodic-qpmad (1.0.2-1stretch) stretch; urgency=high

  * Added missing dependency in package.xml.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 30 Dec 2019 23:00:00 -0000

ros-melodic-qpmad (1.0.1-1stretch) stretch; urgency=high

  * Doxygen documentation.
  * Initial ROS release.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 23 Dec 2019 23:00:00 -0000

=== debian/control ===
Source: ros-melodic-qpmad
Section: misc
Priority: optional
Maintainer: Alexander Sherikov <asherikov@yandex.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev
Homepage: https://github.com/asherikov/qpmad
Standards-Version: 3.9.2

Package: ros-melodic-qpmad
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: qpmad QP solver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-qpmad//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
